<template>
  <article class="view view--forum-topics">
    <TopicList :route="topicsRoute" :section="section" :username="username" :offset="offset" :limit="limit" />
  </article>
</template>

<script>
import { computed, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper } from '../../../core'
import TopicList from '../../components/topic-list.vue'

export default {
  name: 'ForumTopicsView',
  components: {
    TopicList,
  },
  setup() {
    const store = useStore()
    const route = useRoute()

    const topicsRoute = computed(() => {
      return { name: 'forum-topics' }
    })

    const section = computed(() => {
      return ValidationHelper.getString(route.query.section, '')
    })

    const username = computed(() => {
      return ValidationHelper.getString(route.query.username, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const title = computed(() => {
      const usernameText = username.value ? `${username.value}'s ` : ''
      const sectionText = section.value ? `${section.value} ` : ''
      return `${usernameText}${sectionText}Topics`
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    store.dispatch('core/setTitle', title.value)
    store.dispatch('core/setBreadcrumbs', breadcrumbs.value)

    return {
      topicsRoute,
      section,
      username,
      offset,
      limit,
    }
  },
}
</script>
